// Part of CAPer, to Color Text in the NS 3.x TextObj
// Hacked from old 2.1 sources, so take with a grain of salt

#import "CAPInstallObject.h"
#import "ShowTextControler.h"
#import "FindManager.h"

@implementation ShowTextControler
static id zoneList = nil;

+ (NXZone *)newZone
{
    if (!zoneList || ![zoneList count]) {
	return NXCreateZone(vm_page_size, vm_page_size, YES);
    } else {
	return (NXZone *)[zoneList removeLastObject];
    }
}

+ (void)reuseZone:(NXZone *)aZone
{
    if (!zoneList) zoneList = [List new];
    [zoneList addObject:(id)aZone];
}


+ newFromFile:(const char *)fileName
{
    NXStream *stream = NULL;
    id docWin;		/* Window belonging to this document. */
    id textObj;		/* The text object we put in the window. */
    NXRect textFrame;	/* The frame of the text object in our window */

    char txtfile[1024];
    char cmd[1024];
    struct stat stat_buffer;

    sprintf(txtfile,"/tmp/CAPer%d.cat",getpid());
    unlink(txtfile);

    // relying on system() is not optimal, but who cares...
    sprintf(cmd,"/usr/ucb/man -M /usr/local/man %s | uniq | tr -d \"_\" > %s",fileName, txtfile);
    system(cmd);

    if (stat(txtfile, &stat_buffer)) {
	return NULL;
    }

    // anything there? 80 chars are arbitary
    if (stat_buffer.st_size<80L) {
	unlink(txtfile);
	return NULL;
    }
    
    if (fileName && !(stream = NXMapFile(txtfile, NX_READONLY))) {
	return NULL;
    }

    self = [[self allocFromZone:[self newZone]] init];
    
    if (![NXApp loadNibSection:"Showtext.nib" owner:self withNames:NO fromZone:[self zone]]) {
	NXLogError ("Can't find Showtext.nib!");	
	NXCloseMemory (stream, NX_FREEBUFFER);
        [self free];
	return nil;
    }

    /* this and others will cause a warning, this is *OLD* code so ignore */
    coloringList = [[List alloc] init];

    /*
     * Loading the nib file above sets the document outlet to the
     * scrollview; so we can use this outlet to get at the window & such.
     */
    docWin = [document window];
    [[document docView] getFrame:&textFrame];
 
    /*
     * Put the window offset from the previous document window... If no
     * previous window exists, or the main window is undetermined, then
     */ 
    if ([((CAPInstallObject *)[NXApp delegate]) mainTextWindowControler]) {
	NXRect winFrame, winLoc;
	[[[(ShowTextControler *)[(CAPInstallObject *)[NXApp delegate] mainTextWindowControler] document] window] getFrame:&winFrame];
	[[docWin class] getContentRect:&winLoc
			forFrameRect:&winFrame
			style:[docWin style]];
	[docWin moveTo:NX_X(&winLoc) + 10.0 :NX_Y(&winLoc) + 10.0];
    }
	
     [docWin setDelegate:self];

    if (stream) {
	textObj = [document docView];

	[textObj setHorizResizable:YES];
	[textObj setNoWrap];
	[textObj setRetainedWhileDrawing:NO];
	[textObj readText:stream];
	//[textObj setSel:[textObj textLength] :0];

	//[textObj replaceSel:text];
	[self setName:fileName];
	[textObj setHorizResizable:NO];
	//NXCloseMemory (stream, NX_FREEBUFFER);
    } else {
	textObj = [document docView];

	[self setName:"UNTITLED"];
	[textObj setNoWrap];
	[textObj setRetainedWhileDrawing:NO];
    }

    /*
     * Put this new text object in the window and free the IB-created one.
     */
    [textObj setVertResizable:YES];		// Grow down as you type
    [textObj setHorizResizable:NO];		// But not sideways 
    [textObj setAutosizing:NX_WIDTHSIZABLE];	// Size horizontally when resized

    [textObj setDelegate:self];
    [textObj sizeToFit];
    /*
     * Set various parameters.
     */
    [document setAutoresizeSubviews:YES];

    [document display];

    [docWin makeKeyAndOrderFront:self];

    unlink(txtfile);

    return self;
}

- document
{
	return document;
}

- markMatches:(char *)currentText
{
	id textO;
	NXStream *stream;	

	if((textO =[document docView]) == nil)
		return self;
	else {
	const char *replaceBuf;
	NXSelPt start, end;
	int len;

	replaceBuf = currentText;		
	
	len = [textO textLength];
	if(len == 0)
		return self;
	[textO getSel:&start :&end];
	[textO setTextColor:NX_COLORBLACK];
	[textO setSel:0:0];

	stream = [textO stream];
	[[document window] setTitle:"Preparing..."];
	if(1)
	{
		int begin = 0, most, i, flen, found = NO, offset;
		int rlen = strlen(replaceBuf);


		offset = 0;
		most = len;

		if(most < 1)
			return self;
			
		NXSeek(stream, offset, NX_FROMSTART);
		textStart = (char *)realloc(textStart, most);
		NXRead(stream, textStart, most);
		
		flen = strlen(currentText);
		for(;;)
		{
			if(1)
			{
				i = search(currentText, textStart, begin, most, 0);
			}
			if((i < 0) || (i + flen) > len)
			{
				[self perform:@selector(doTheColoring) with:self afterDelay:100 cancelPrevious:NO];
				return self;
			}
			else
			{
				id newSelToBe;
				if(!found)
				{
					found = YES;
				}

				newSelToBe= [SelectionToBeColored newWithSelection:i + offset:i + offset + flen:textO ];
				[coloringList addObject:newSelToBe];
				
				offset += rlen - flen;
				begin = i + flen;
				most = len - begin;
				if(most < 0)
				{
					// not found
					[self perform:@selector(doTheColoring) with:self afterDelay:1 cancelPrevious:NO];
					return self;
				}
			}
		}
	}
	[textO setSel:0:0];	
	}

	[self perform:@selector(doTheColoring) with:self afterDelay:100 cancelPrevious:NO];

	return self;
}

- windowWillClose:sender
{
	while ([coloringList count]) {
		[[coloringList removeLastObject] free];
	}
	[self perform:@selector(free) with:self afterDelay:10 cancelPrevious:NO];
	return self;
}

- doTheColoring
{
	int nCount;
	if (nCount=[coloringList count]) {
		id theObj=[coloringList lastObject];
		[coloringList removeLastObject];
		if (nCount>1)
			[theObj doColoringAndFree:YES];
		else {
			[theObj doColoringAndFree:NO];
			[theObj setSelection];
			[theObj free];
		}
		[self perform:@selector(doTheColoring) with:self afterDelay:0 cancelPrevious:YES];
	} else {
    		 [[document docView] sizeToFit];
		 [[document docView] display];

		 [[document window] setTitleAsFilename:name];
		 [[document window] flushWindow];
	}
	return self;
}

- setName:(const char *)documentName
{
    documentName = documentName ? documentName : "";
    if (documentName != name) {
	free(name);
	name = NXCopyStringBufferFromZone (documentName, [self zone]); 
	[[document window] setTitleAsFilename:name];
    }
    return self;
}

- free
{
	[(CAPInstallObject *)[NXApp delegate] invalidateMainTextWindowControler:self];
	if (name) free(name); name=NULL;
	if (textStart) free(textStart); textStart=NULL;
	return [super free];
}

@end

//-----------------------------------------------------------------------------

@implementation SelectionToBeColored
{
	id theText;
	int start;
	int end;
}

+ newWithSelection:(int)newstart:(int)newend:(id)newText
{
	self=[[SelectionToBeColored alloc] init];
	theText=newText;
	start=newstart;
	end=newend;
	return self;
}

- doColoringAndFree:(BOOL)bFree
{
	[[theText window] disableDisplay];
	[theText setSel:start :end];
	[theText setSelColor:NX_COLORRED];
	[theText selectNull];
	[[theText window] reenableDisplay];
	if (bFree)
		return [super free];	
	else
		return self;
}
- setSelection
{
	[theText setSel:start :end];
	[theText scrollSelToVisible];
	return self;
}

@end